# $Id: DbUtil.pm,v 1.1 2005/11/25 13:08:05 pythontech Exp $
package DbUtil;
use strict;
use DB_File;
#use Fcntl;

#-----------------------------------------------------------------------
#	Read contents of db file and return string representation
#-----------------------------------------------------------------------
sub ::dbread {
    my($filename) = @_;
    my %hash;
    my $tie = tie %hash, 'DB_File', $filename, O_RDONLY
	or die "Cannot tie: $!\n";
    my $dump = '';
    foreach my $key (sort keys %hash) {
	$dump .= &e($key).' = '.&e($hash{$key})."\n";
    }
    return $dump;
}

#-----------------------------------------------------------------------
#	Write a new db file from a hash or string
#-----------------------------------------------------------------------
sub ::dbwrite {
    my($filename, $data) = @_;
    my %hash;
    my $tie = tie %hash, 'DB_File', $filename, O_RDWR|O_CREAT, 0600
	or die "Cannot tie: $!\n";
    if (ref($data) eq 'HASH') {
	while (my($key,$value) = each %$data) {
	    $hash{$key} = $value;
	}
    } elsif (ref($data) eq '') {
	foreach my $line (split /\n/, $data) {
	    if (my($key,$value) = $line =~ /^(\S*) = (\S*)/) {
		$hash{&d($key)} = &d($value);
	    }
	}
    } else {
	die "Unexpected ".ref($data)." data in dbwrite\n";
    }
}

sub e {
    my $text = shift;
    # Escape non-ASCII and '%' and '+'
    $text =~ s![^\x20-\x24\x26-\x3a\x3c-\x7e]!sprintf("%%%02X",unpack('C',$&))!eg;
    $text =~ s! !+!g;
    return $text;
}

sub d {
    my $text = shift;
    $text =~ s!\+! !g;
    $text =~ s!%([0-9a-fA-F]{2})!pack('C',hex($1))!eg;
    return $text;
}

1;
